unit Calpnl;

 {CalPnl Lives!!!   Here is the (maybe-maybe not) long awaiten next step to a perfect Calendar-Component
  AND the best is its FREEWARE!!!

  History (complete? I dont know) :
   -Peter Crain (Australia) builds the first Version    (I think with D1)
     by using code from Robert Vivrette(Freeware-TDateEdit-Form)

   -Roland Weinschuetz adds Functionality for better Europe/German-Date-Support  (with D2?)

   -New Functionality (03.12.98) added by me (Harri Kasulke - Harri.Kasulke@Okay.net)
    -THIS IS FREEWARE AND WILL BE FREEWARE
    -NO SUPPORT by me!
    -BUGS are YOUR PROBLEM!
    -tested only with D3 and GermanDate
    -Sorry to Peter Crain, but couldnt find a way to send you this new Version (CS:100237,2735 isnt valid)

   -Optimized 04.12.98 (I forget to remove the old Button-Handling) by me (Harri Kasulke - Harri.Kasulke@Okay.net)
  
 *** BEGIN of New Functions by HK *********************************************************************************************************

  ***Optimized 04.12.98 (I forget to remove the old Button-Handling)

  ***NEW (03.12.98) added and changed by Harri Kasulke marked with HK: in the .PAS file.
  -Calendar-Header-Buttons now are BitBtns and support hints (If you want other Hint-Texted, Change the Procedure ShowButtons)
  -ColWeekend splitted to ColSaturday,ColSunday
  -property ShowWeeks added (Shows the Weeknumbers!)
  -property ShowButtonHints added
  -DblClick works now only in the Calendar-Area

  -Functions for Weekhandling (This functions should help building Querys for filtering/searching WeekNo)
   Example:
    I would like to query all custumers of LastWeek:
     -Take the now-TDateTime and sub 7 (7 Days)
     -Week1stDay:=WeeksFirstDay(aDate: TDateTime) : TDateTime; to get the TDateTime of Week-Beginning
     -WeekLastDay:=WeeksLastDay(aDate: TDateTime) : TDateTime; to get the TDateTime of Week-Ending
     now you have 2 TDateTime-Objects for using in a Query!!!
     (LIKE:  SELECT * FROM Customer
             WHERE Date>=:Param1(To fill with Week1stDay)
             AND Date <=:Param2(To fill with WeekLastDay)
     ) //EXAMPLE ONLY-NOT TESTED!!!

  -I put the functions DaysInMonth, IsValidDate to the public-area, because these functions
   are perfect to check a Date

  This Component was tested only with Delphi3 by using the GermanDate-Option !!!

  TODO-Section (To improve by YOU, maybe by me):
   -Year2k-Test - I Think it works
   -Optimizing to reduce the Code
   -Size-Checking to avoid strange Effects
   -Find Bugs and Remove!!!

  *** END of New Functions by HK **********************************************************************************************************

  *** Orginal Comments: ***

  Posted in the hope that I can repay a little of my enormous debt to
  those many unselfish people who have made my life easier with freeware
  and code snippets.

                                -o0o-

  TCalenPnl, a freeware Calendar descended from TCustomPanel. The really
  hard work for this component was done by Robert Vivrette, and is adapted
  from his freeware TDateEdit form.

                           ******NEW******
  Roland Weinschuetz has added a considerable degree of functionality by
  adding some sorely needed properties to TCalenPnl.  Roland agreed that it
  would benefit from some European style date facilities, and did an excellent
  job of implementing them.  The new properties are listed below.
                         ******Resume******

  I needed a panel-based Calendar, and adapted the CalPop code to suit.
  TCalenPnl retains all the properties of a TPanel, and adds a few more.
  Some of the interesting published properties are...

  ShowDate:	Shows\Hides the buttons and 'MMMMM YYYY' display
  		above the abbreviated day names at the top. The Months
                or Years can then be changed programmatically by
                ScrollBars or similar.

  DayWidth:	Uses 1 to 3 characters (M, Mo, Mon) to define the day name.

  Font:		Big deal! Actually, the point is that the Font can be
  		changed (typically the size would be changed) when 
                TCalenPnl is Resized (OnResize).

  OnDateChange:	A centralized event that allows users to change Labels,
                ScrollBars, Graphs or ProgressBars when the CalendarDate
                property is changed, internally or externally.

  Some interesting Public properties...

  CalendarDate: A TDateTime property that you can read or write to
  		programmatically. The fractional part of CalendarDate,
                i.e. the time, is not stored.

  WeekNumber: 	An integer representing the... Week number of the TCalenPnl.Year.

  DayOfYear: 	Integer value for days that have passed, in the current
  		(CalendarDate) year.

  DaysInYear:	Integer, can be either 365 or 366. It could have just as
  		easily been Boolean (it calls the Boolean IsLeapYear protected
                Function), but it suited my project.

  .Day, .Month, .Year are all integer Public Properties.

  ***NEW, added by Roland, and marked  // RW: in the .PAS file.

  GermanDate:   Boolean switch to enable German date.
  ColHoliday,
  ColWeekend,
  ColMarked:    TColor, to mark important dates.
  Holidays,
  Markdays:     TStrings, for storing holidays and special days as strings.

  There is some repetition in the code, as Robert's CalPop relies on the date
  being changed only by the buttons, therefore only in increments of one. I
  required TCalenPnl to be able to be set by other controls, so there is some
  duplication.  A really clever programmer, over a rainy weekend, could re-do
  the code to shrink it a touch.

  You may have to look closely at some of the code, as it has been written to
  prevent a user entering an invalid date, which can happen with a ScrollBar.
  If the date highlighted is 31 August, and the user scrolls to September, the
  CalendarDate.Day is reset to the DaysInMonth (ie, 30), to prevent an error.
  Shouldn't be a problem as it almost guarantees no errors, but be aware.

  If you use 'MMMM DD YYYY' format in your Win International settings, ie US
  users, then the example above would use August 31. In other words, the code
  is 'Internationalized', to that extent.

  While CalPnl.PAS  and the CalPnl.DCR have been produced in Delphi 2.0, there
  is no reason why the .PAS would not work in 16 bit Delphi, apart from a few
  // comments.

  Roland Weinschuetz has added the dynamic StartofWeek option that the earlier
  TCalenPnl needed.

  If you have any criticisms or suggestions, please send them to me...

                     Peter Crain
                     Brisbane, Queensland.
                     AUSTRALIA.
                     Compuserve 100237,2735
}

{$R CALPNL.RES}         //Includes the Resource-File for TBitBtn Glyphs

interface

uses
 SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, Forms, Dialogs, extctrls, StdCtrls,
 Menus, Buttons;
const
 BORDER = 2;
 DAYS_IN_MONTH: array[1..12] of Integer = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
 BUTTON_WIDTH = 16;

type
 TDayWidth = (dw1Char, dw2Char, dw3Char);
 TPaintJob = (All, Header, Dates);

 TDateType = record
  aYear, aMonth, aDay : Word;
 end; {Record}

 TCalButton = class(TBitBtn)  {HK:Added}
  //For Special Button-Handling, not used now!
 end;

 TCalenPnl = class(TCustomPanel)
 private
 MouseX,MouseY: integer;                      {HK: Added}
 DecMonthButton: TCalButton;
 IncMonthButton: TCalButton;
 FShowButtonHints: Boolean;
 g_MouseDown : BOOL;
 g_PrevYear, g_PrevMonth : Word;
 g_DateArray : array[1..42] of string[3];     {HK: Changed for showing days of next and prev month}
 g_CurrDateIndex : Integer;
 g_PrevDateIndex : Integer;
 g_WeekNumbers : Array[0..5] of string [2];   {HK: Added for WeekNo}
 // RW: Changes for german date:
 // index +1; Sunday is copied to last index
 g_DayTitles : Array[0..7] of string[3]; {moved from const to enable Int ShortDayNames}
 FOnDateChange: TNotifyEvent;
 FShowDate: Boolean;
 FUseLongDate: Boolean;
 g_RectHeight: Integer;
 g_Width: Integer;
 HeadingRect: TRect;
 CalendarRect : TRect;
 FMonth: Integer;
 FDay: Integer;
 FYear: Integer;
 FDayWidth: TDayWidth;
 FCalendarDate: TDateTime;
 // RW: Boolean to switch to german date
 FGermanDate: Boolean;
 // RW: Special colors may be chosen
 FShowWeeks: Boolean; {HK: Show WeekNo and Complete Weeks}
 FColHoliday: TColor;
 FColSunday: TColor;    {HK: Changed}
 FColSaturday: TColor;  {HK: to add sep. Color to Staturday}
 FColMarked: TColor;
 // RW: Properties for storing holidays and special days as strings
 // format: dd.mm.
 FHolidays: TStrings;
 FMarkdays: TStrings;

 procedure SetCalendarDate(aDate: TDateTime);
 procedure SetMonth(Value: Integer);
 procedure SetDay(Value: Integer);
 procedure SetYear(Value: Integer);
 function GetShowDate: Boolean;
 procedure SetShowDate(Value: Boolean);
 procedure SetDayWidth(Value: TDayWidth);
 function GetUseLongDate: Boolean;
 procedure SetUseLongDate(Value: Boolean);
 function JulDate1stWeek(JD : TDateTime) : TDateTime;
 function WeekNo(JDate : TDateTime): Integer;
 function GetWeekNumber: Integer;
 function DOY (y, m, d : Word): Integer;
 function GetDayOfYear: Integer;
 function GetDaysInYear: integer;
 // RW: this one sets the german date
 procedure SetGermanDate(Value: Boolean);
 // RW: adapted DayOfWeek-function to fit german date
 procedure SetShowWeeks(Value: Boolean); {HK: Added}
 function rDayOfWeek(vDate: TDateTime) : Integer;
 // RW: set color properties
 procedure SetColHoliday(Value: TColor);
 procedure SetColSunday(Value: TColor);
 procedure SetColSaturday(Value: TColor);
 procedure SetColMarked(Value: TColor);
 // RW: build string lists
 procedure SetHolidays(Value: TStrings);
 procedure SetMarkdays(Value: TStrings);
 // RW: returns TRUE if parameter denotes a special day
 function CheckHoliday(DateList: TStrings; sd: PChar; m: integer) : Boolean;
 function PointInRect( const rectTest: TRect; X, Y: integer ): boolean;

 protected
  procedure Paint; override;
  procedure DateChange;
  procedure DrawMonthHeader;
  procedure DrawDaysHeader;
  procedure DrawDates;
  procedure DrawWeeks; {HK: Added}
  procedure DrawFocusFrame(nIndex : Integer);
  procedure LoadDateArray;
  function GetMonthBegin: Integer;
  function IsLeapYear(AYear: Integer): Boolean;
  function SetDate(nDays : Integer): Boolean;
  function GetLeftButtonRect : TRect;
  function GetRightButtonRect : TRect;
  function GetRectFromIndex(nIndex : Integer): TRect;
  function GetIndexFromDate : Integer;
  function GetIndexFromPoint(nLeft : Integer ; nTop : Integer) : Integer;
  procedure ShowButtons;  //HK: Added, DrawButtons removed
  procedure HideButtons;  //HK: Added
  procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  procedure DblClick; override;                             {HK: Added}
  procedure DecMonth(Sender: TObject);                      {HK: Added}
  procedure IncMonth(Sender: TObject);                      {HK: Added}
  
  function ValidDate(aDate: TDateType) : Boolean;
  
 public
  constructor Create(AOwner: TComponent); override;
  // RW: frees special date string lists
  destructor Destroy; override;
  function DaysInMonth(nMonth, nYear : Integer): Integer;   {HK: Changed to public}
  function IsValidDate(yy,mm,dd: integer) : Boolean;        {HK: Public Check of Date}
  function WeeksFirstDay(aDate: TDateTime) : TDateTime;     {HK: This function helps to Filter/Query a Table by Weeks}
  function WeeksLastDay(aDate: TDateTime) : TDateTime;      {HK: This function helps to Filter/Query a Table by Weeks}

  property Day: Integer read FDay write SetDay;
  property Month: Integer read FMonth write SetMonth;
  property Year: Integer read FYear write SetYear;
  property CalendarDate: TDateTime read FCalendarDate write SetCalendarDate;
  property WeekNumber: Integer read GetWeekNumber;
  property DayOfYear: Integer read GetDayOfYear;
  property DaysInYear: Integer read GetDaysInYear;

 published
  property Align;
  property BevelInner default bvLowered;
  property BevelOuter default bvRaised;
  property BevelWidth default 1;
  property BorderStyle default bsNone;
  property BorderWidth default 1;
  property Color;
  property Ctl3D;
  property Cursor;
  property DragCursor;
  property DragMode;
  property Enabled;
  property Font;
  property Height default 160;
  property HelpContext;
  property Hint;
  property Left;
  property Locked;
  property Name;
  property ParentColor;
  property ParentCtl3D;
  property ParentFont;
  property ParentShowHint;
  property PopupMenu;
  property ShowHint;
  property TabOrder;
  property TabStop;
  property Tag;
  property Top;
  property Visible;
  property Width default 160;
  property ShowDate: Boolean read GetShowDate write SetShowDate default False;
  property UseLongDate: Boolean read GetUseLongDate write SetUseLongDate; {defaults to False}
  property DayWidth: TDayWidth read FDayWidth write SetDayWidth default dw2Char;
  property OnClick;
  property OnDblClick;
  property OnDragDrop;
  property OnDragOver;
  property OnEndDrag;
  property OnEnter;
  property OnExit;
  property OnMouseDown;
  property OnMouseMove;
  property OnMouseUp;
  property OnResize;
  property OnDateChange: TNotifyEvent read FOnDateChange write FOnDateChange;
  // RW: these will be visible in the object-inspector
  property GermanDate: Boolean read FGermanDate write SetGermanDate;
  property ShowWeeks: Boolean read FShowWeeks write SetShowWeeks;    {HK: Added}
  property ColHoliday: TColor read FColHoliday write SetColHoliday;
  property ColSunday: TColor read FColSunday write SetColSunday default clPurple;   {HK: Added}
  property ColSaturday: TColor read FColSaturday write SetColSaturday default clPurple;  {HK: Added}
  property ColMarked: TColor read FColMarked write SetColMarked;
  property Holidays: tstrings read FHolidays write SetHolidays;
  property Markdays: tstrings read FMarkdays write SetMarkdays;
  property ShowButtonHints: Boolean read FShowButtonHints write FShowButtonHints;  {HK:Added}

 end; {of Class}

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TCalenPnl]);
end;

function TCalenPnl.PointInRect( const rectTest: TRect; X, Y: integer ): boolean;
begin
  Result := ( ( X >= rectTest.Left ) and ( X <= rectTest.Right ) and
     ( Y >= rectTest.Top ) and ( Y <= rectTest.Bottom ) );
end;

function TCalenPnl.GetShowDate: Boolean;
begin
 Result := FShowDate;
end;

procedure TCalenPnl.SetShowDate(Value: Boolean);
begin
 if Value <> FShowDate then
  begin FShowDate := Value;
  Refresh;
 end;
end;

function TCalenPnl.GetUseLongDate: Boolean;
begin
 Result := FUseLongDate;
end;

procedure TCalenPnl.SetUseLongDate(Value: Boolean);
begin
 if Value <> FUseLongDate then
  begin FUseLongDate := Value;
  Refresh;
 end;
end;

procedure TCalenPnl.SetDayWidth(Value: TDayWidth);
begin
 if Value <> FDayWidth then
  begin FDayWidth := Value;
  Refresh;
 end;
end;

constructor TCalenPnl.Create(AOwner: TComponent);
var
 iCount: Integer;
 aY, aM, aD: Word;
begin
 inherited Create(AOwner);
 // RW: Create the stringlists for special days
 FHolidays := TStringList.Create;
 FMarkdays := TStringList.Create;
 Height := 160;
 Width := 160;
 BevelOuter := bvRaised;
 BevelInner := bvLowered;
 BevelWidth := 1;
 BorderStyle := bsNone;
 BorderWidth := 1;
 DayWidth := dw2Char;
 for iCount := 0 to 6 do g_DayTitles[iCount] := ShortDayNames[iCount +1];
 // RW: copy sunday to index 7 for german date
 g_DayTitles[7] := ShortDayNames[1];
 FCalendarDate := Date;
 FShowDate := False;
 DecodeDate(FCalendarDate, aY, aM, aD );
 FMonth := Integer(aM);
 FDay := Integer(aD);
 FYear := Integer(aY);
 g_PrevDateIndex := 0;
 LoadDateArray;
 SetDate(0);
 g_MouseDown := False;

 //HK: Added for Creating the Calendar-Buttons
 DecMonthButton:=TCalButton.Create(Self);
 DecMonthButton.Glyph.LoadFromResourceName(HInstance, 'DECMONTH');
 DecMonthButton.OnClick:=DecMonth;
 DecMonthButton.SetBounds(0,0,0,0); //Default
 DecMonthButton.Hide;
 DecMonthButton.Parent:=Self;

 IncMonthButton:=TCalButton.Create(Self);
 IncMonthButton.Glyph.LoadFromResourceName(HInstance, 'INCMONTH');
 IncMonthButton.OnClick:=IncMonth;
 IncMonthButton.SetBounds(0,0,0,0); //Default
 IncMonthButton.Hide;
 IncMonthButton.Parent:=Self;
end;

// RW: free special date stringlist
destructor TCalenPnl.Destroy;
begin
  FHolidays.Free;
  FMarkdays.Free;
  inherited Destroy;
end;

procedure TCalenPnl.Paint;
var
 dd,iInnerSpace, iWBorder, iHBorder, iInnerW, innerH, iLMargin, iLinesH: Integer;
begin
 inherited Paint;
 iInnerSpace := 0;
 if FShowWeeks then dd:=8              {HK: Added}
  else dd:=7;
 if BorderStyle = bsSingle then iInnerSpace := 1;
 if BevelOuter <> bvNone then iInnerSpace := BevelWidth + iInnerSpace;
 if BevelInner <> bvNone then iInnerSpace:= BevelWidth + iInnerSpace;  { + 1}
 iInnerSpace:= BorderWidth + iInnerSpace;
 {iInnerSpace = the border, including bevels, on 1 side}
 iInnerW := Width - (iInnerSpace * 2);
 iWBorder := iInnerW div 100;
 {g_Width is a product of useable space, not all space}
 {clear space less a border both sides, makes g_Width narrower}
 g_Width := (iInnerW - (iWBorder * 2)) div dd;    {HK: Changed}
 innerH := Height - (iInnerSpace * 2);
 iHBorder := innerH div 100;
 if ShowDate then iLinesH := 8 else iLinesH := 7;
 {take out 2 iHBorder for spacing at top}
 g_RectHeight := (innerH - (iHBorder * 2) ) div iLinesH;
 iLMargin := (iInnerW - (g_Width * dd)) div 2;    {HK: Changed}
 HeadingRect := ClientRect;
 HeadingRect.Top := HeadingRect.Top + iInnerSpace + iHBorder;
 HeadingRect.Left := HeadingRect.Left + iInnerSpace + iLMargin ;
 HeadingRect.Right := HeadingRect.Left + (g_Width * dd) ;   {HK: Changed}
 if ShowDate then HeadingRect.Bottom := HeadingRect.Top + (g_RectHeight * 2)
   else HeadingRect.Bottom := HeadingRect.Top + g_RectHeight;
 CalendarRect := HeadingRect;
 CalendarRect.Top := HeadingRect.Bottom ;
 CalendarRect.Bottom := CalendarRect.Top + (g_RectHeight * 6);

 if FShowWeeks then CalendarRect.Left := HeadingRect.Left + (g_Width) ; {HK: Added for showing WeekNo}
 Canvas.Brush.Color := clBtnFace;
 Canvas.FillRect(CalendarRect);
 g_CurrDateIndex := FDay + GetMonthBegin - 1;
 if ShowDate then    //HK:Changed
  begin
   ShowButtons;
   DrawMonthHeader;
  end
  else begin
   HideButtons;
  end;
 DrawDaysHeader;
 DrawDates;
 if FShowWeeks then DrawWeeks;  {HK: Added}
 DrawFocusFrame(g_CurrDateIndex);
end;

procedure TCalenPnl.DrawMonthHeader;
var
   iRectHt, iSpaces, iIndent: Integer;
   sMonth : String;
   pMonth : PChar;
   TempRect : TRect;
begin
  with Canvas do
   begin
    Font.Color := clBlack;
    Font.Style := [fsBold];
    if UseLongDate then sMonth := FormatDateTime( 'mmmm yyyy', FCalendarDate )
      else sMonth := FormatDateTime( 'mmm yyyy', FCalendarDate );
    pMonth := StrAlloc( Length( sMonth ) + BORDER );
    StrPCopy( pMonth, sMonth );
    TempRect := HeadingRect;
    iRectHt := HeadingRect.Bottom - HeadingRect.Top;
    iIndent := (TempRect.Right - TempRect.Left) div 20;
    iSpaces := (iRectHt div 20) * BORDER;
    if iSpaces = 0 then iSpaces := 1;
    TempRect.Top := TempRect.Top + iSpaces ;
    TempRect.Bottom := TempRect.Top + g_RectHeight ;
    TempRect.Left := TempRect.Left + iIndent + BUTTON_WIDTH + 1;
    TempRect.Right := TempRect.Right - (iIndent + BUTTON_WIDTH + 1);
    Brush.Color := clBtnFace;
    Brush.Style := bsSolid;
    FillRect( TempRect );
    DrawText( Handle, pMonth, Length( sMonth ), TempRect,
             ( DT_CENTER or DT_TOP or DT_SINGLELINE ) );
   end;
  StrDispose( pMonth );
end;

procedure TCalenPnl.DrawDaysHeader;
var
   i,iDayWidth: Integer;
   pDay: PChar;
   ARect: TRect;
   pCW: PChar;         {HK: Added}
begin
  pCW := StrAlloc( 2 );
  Case DayWidth of
   dw1Char : iDayWidth := 1;
   dw2Char : iDayWidth := 2;
   dw3Char : iDayWidth := 3;
   else iDayWidth := 1;
  end;
  pDay := StrAlloc( 3 );

  ARect := HeadingRect;
  ARect.Right := ARect.Left + g_Width;

  if ShowDate then ARect.Top := ARect.Top + g_RectHeight ;
  { Cycle through the days }

  {HK: Added for showing WeekNo BEGIN}
  if fShowWeeks then
  begin
   if FGermanDate then StrPCopy( pCW, 'KW')
    else StrPCopy( pCW, 'CW');

   Canvas.Font.Color := clTeal;
   DrawText( Canvas.Handle, pCW, 2, ARect,( DT_CENTER or DT_VCENTER or DT_SINGLELINE ) );

   ARect.Left := ARect.Right;
   ARect.Right := ARect.Right + g_Width;
  end;
  {HK: Add-END}

  Canvas.Font.Style := [fsBold]; {make Days Bold}

  for i := 0 to 6 do
     begin
        // RW: german date: (i=5) or (i=6)
        if not FGermanDate then
        begin
           Canvas.Font.Color := clBlack;                               {HK: Changed}
           if (i = 0) then Canvas.Font.Color := ColSunday;             {HK: Changed}
           if (i = 6) then Canvas.Font.Color := ColSaturday;           {HK: Changed}
           StrPCopy( pDay, Copy(g_DayTitles[i], 1, iDayWidth));
        end
        else
        begin
           Canvas.Font.Color := clBlack;                               {HK: Changed}
           if (i = 6) then Canvas.Font.Color := ColSunday;             {HK: Changed}
           if (i = 5) then Canvas.Font.Color := ColSaturday;           {HK: Changed}
           StrPCopy( pDay, Copy(g_DayTitles[i+1], 1, iDayWidth));
        end;

        DrawText( Canvas.Handle, pDay, iDayWidth, ARect,
                ( DT_CENTER or DT_VCENTER or DT_SINGLELINE ) );
        ARect.Left := ARect.Right;
        ARect.Right := ARect.Right + g_Width;
     end;
     Canvas.Font.Color := clBlack;
     Canvas.Font.Style := [];  {reset Days <> Bold}
     { Draw line below days }
     with Canvas do
        begin
           ARect.Top := CalendarRect.Top - 4;
           ARect.Left := HeadingRect.Left;
           ARect.Right := HeadingRect.Right;
           Pen.Color := clBtnHighlight;
           MoveTo( ARect.Left , ARect.Top);
           LineTo( ARect.Right, ARect.Top );
           Pen.Color := clBtnShadow;
           MoveTo( ARect.Left,  ARect.Top + 1 );
           LineTo( ARect.Right, ARect.Top + 1  );
        end;
     StrDispose( pDay );
end;

procedure TCalenPnl.DrawDates;
var
   nIndex, nWeek, nDay: Integer;
   pDate1,pDate2: string;      {HK: Added}
   pDate: PChar;
   TempRect: Trect;
begin
 pDate := StrAlloc( 3 );
 With Canvas do
  begin
  { Define normal font }
   Font.Style := [];
   Pen.Color := clBlack;
   { Cycle through the weeks }
   for nWeek := 1 to 6 do
    begin
     { Cycle through the days }
     for nDay := 1 to 7 Do
      begin
       nIndex := nDay + ( ( nWeek - 1 ) * 7 );

       {HK: Added and Changed BEGIN}
       pDate1:=g_DateArray[nIndex];
       pDate2:=pDate1;
       Delete(pDate1,1,1);
       StrPCopy( pDate, pDate1);
       {HK: Add/Change-END}
       TempRect := CalendarRect; {OPTIMIZE: can it go outside loop?}
       With TempRect Do
        begin
         Left := Left + (g_Width * (nDay - 1));
         Top := Top + (g_RectHeight * (nWeek -1));
         Bottom := Top +  g_RectHeight ;
         Right := Left + g_Width;
        end;

        {HK: Changed BEGIN}
        Font.Color := clBlack;
        if not FGermanDate then
        begin
         if nDay = 1 then Font.Color := ColSunday;
         if nDay = 7 then Font.Color := ColSaturday;
        end
        else begin
         if nDay = 7 then Font.Color := ColSunday;
         if nDay = 6 then Font.Color := ColSaturday;
        end;
        {HK: Change-END}

        if CheckHoliday(Holidays, pDate, FMonth) then
           Font.Color := ColHoliday;
        if CheckHoliday(Markdays, pDate, FMonth) then
              Canvas.Font.Color := ColMarked;
        {HK: Added BEGIN}
        Font.Style := [];
        if pDate2[1]='-' then
        begin
         Font.Color:=clBtnShadow;
        end;
        {HK: Added-END}

        DrawText( Handle, pDate, (Length(g_DateArray[nIndex])-1),      {HK: Changed}
          TempRect, ( DT_CENTER or DT_VCENTER or DT_TOP or DT_SINGLELINE ) );
        Font.Color := clBlack;
       end;
      end;
     end;
     StrDispose( pDate );
end;

{HK: New procedure to Draw the WeekNo in the Calendar}
procedure TCalenPnl.DrawWeeks;
var
   nWeek, nDays: Integer;
   pWeek: PChar;
   TempRect: Trect;
   d       : TDateTime;
   x,i   : Integer;
   tWeek, nWeeks :Integer;
   rtop  : Integer;

begin
 nDays:=DaysInMonth(FMonth,FYear);
 tWeek:=0;
 i:=0;
 for x:=1 to nDays do
 begin
  d:=EncodeDate(FYear,FMonth,x);
  nWeek:=WeekNo(d);
  if nWeek<>tWeek then
  begin
   g_WeekNumbers[i]:=IntToStr(nWeek);
   i:=i+1;
   tWeek:=nWeek;
  end;
 end;
 nWeeks:=i-1;
 pWeek := StrAlloc( 3 );
 TempRect := CalendarRect;
 TempRect.Left:=TempRect.Left-g_Width;
 rtop:=TempRect.Top;
 With Canvas do
 begin
  Font.Style := [];
  Pen.Color := clBlack;
  Font.Color := clTeal;
  for x:=0 to nWeeks do
  begin
   StrPCopy( pWeek, g_WeekNumbers[x] );
   With TempRect Do
   begin
    Top := rtop + (g_RectHeight * (x));
    Bottom := Top +  g_RectHeight ;
    Right := Left + g_Width;
   end;
   DrawText( Handle, pWeek, Length( g_WeekNumbers[x] ),
            TempRect, ( DT_CENTER or DT_VCENTER or DT_TOP or DT_SINGLELINE ) );
  end;
  Font.Color := clBlack;    {Restore}
 end;
 StrDispose( pWeek );
end;

procedure TCalenPnl.LoadDateArray;
var
  nIndex : Integer;
  nBeginIndex, nEndIndex : Integer;
  {HK: Added BEGIN}
  aYear,aMonth,aDay : word;
  d1,d2,dd1,dd2 : TDateTime;
  dx1,dx2       : Integer;
  {HK: Add-END}
begin
  nBeginIndex := GetMonthBegin;
  nEndIndex := nBeginIndex + DaysInMonth(FMonth, FYear) - 1;
  {HK: Added BEGIN}
  d1:=EncodeDate(FYear,FMonth,1);
  DecodeDate(d1-1,aYear,aMonth,aDay);
  dd1:=WeeksFirstDay(d1);
  d2:=EncodeDate(FYear,FMonth,DaysInMonth(FMonth, FYear));
  dd2:=WeeksLastDay(d2);
  dx1:=trunc(d1-dd1);
  dx2:=trunc(dd2-d2);
  {HK: Add-END}

  for nIndex := 1 to 42 do
  begin
  {HK: Changed BEGIN}

    If ( nIndex < nBeginIndex ) or ( nIndex > nEndIndex ) Then
    begin
     if ( nIndex < nBeginIndex ) then
     begin
      if FShowWeeks then
       g_DateArray[nIndex] := '-'+IntToStr(aDay-dx1+nIndex)
       else g_DateArray[nIndex] := '   ';
     end
     else begin
      if nIndex-nEndIndex<dx2+1 then
       if FShowWeeks then
        g_DateArray[nIndex] := '-'+IntToStr(nIndex-nEndIndex)
        else g_DateArray[nIndex] := '   '
      else g_DateArray[nIndex] := '   ';
     end;
    end
    else
     g_DateArray[nIndex] := '+'+IntToStr((nIndex-nBeginIndex)+1);
  {HK: Change-END}
  end;
end;

function TCalenPnl.GetMonthBegin: Integer;
var
  FirstDate: TDateTime;
begin
  FirstDate := EncodeDate( FYear, FMonth, 1 );
  // RW: took me long time to find it: central point to adapt date-format
  Result := rDayOfWeek( FirstDate )
end;

function TCalenPnl.DaysInMonth(nMonth, nYear : Integer): Integer;
begin
  Result := DAYS_IN_MONTH[nMonth]; { leap-year Feb is special }
  if ( nMonth = 2 ) and IsLeapYear(nYear) then Inc( Result );
end;

function TCalenPnl.IsLeapYear(AYear: Integer): Boolean;
begin
  Result := (AYear mod 4 = 0) and ((AYear mod 100 <> 0) or (AYear mod 400 = 0));
end;

function TCalenPnl.SetDate(nDays : Integer): Boolean;
var
  aY, aM, aD: Word;
  PrevDay: Word;
begin
 Result := True;
 try
  {Save current date information}
  g_PrevDateIndex := g_CurrDateIndex;
  DecodeDate(FCalendarDate, g_PrevYear, g_PrevMonth, PrevDay);
  {Change the date and update member variables}
  FCalendarDate := FCalendarDate + nDays;
  DecodeDate(FCalendarDate, aY, aM, aD);
  g_CurrDateIndex := ( aD + GetMonthBegin ) - 1;
  {Reload Date Array & paint ONLY if month or year changed}
  If (aM <> g_PrevMonth) or (aY <> g_PrevYear)Then
   begin
    FMonth := aM;
    FYear := aY;
    LoadDateArray;
   end;
  FDay := aD;
 except
  MessageBeep(MB_ICONEXCLAMATION);
  Result := False;
 end;
end;

Function TCalenPnl.ValidDate(aDate: TDateType) : Boolean;
Begin       {is cool as no exception is generated by invalid date}
 ValidDate := True;
  With aDate do
   Begin
    If (aMonth > 12) Or (aMonth < 1) Or (aDay < 1) or (aYear < 1) or (aYear > 9999) then
     Begin
      ValidDate := False;
      Exit;
     End;
    If (aMonth = 2) And IsLeapYear(Integer(aYear)) then Dec(aDay);
    If aDay > DaysInMonth(aMonth, aYear) then ValidDate := False;
   End;
End;

Function TCalenPnl.IsValidDate(yy,mm,dd: integer) : Boolean;        {HK: Added}
var d: TDateType;
begin
 d.aYear:=yy; d.aMonth:=mm; d.aDay:=dd;
 result:=ValidDate(d);
end;

function TCalenPnl.WeeksFirstDay(aDate: TDateTime) : TDateTime;      {HK: Added}
begin
 result:=aDate-(rDayOfWeek(aDate)-1);
end;

function TCalenPnl.WeeksLastDay(aDate: TDateTime) : TDateTime;       {HK: Added}
begin
 result:=aDate+(7-rDayOfWeek(aDate));
end;


procedure TCalenPnl.SetCalendarDate(aDate: TDateTime);
var
 aYear, aMonth, aDay: Word;
begin
try
 if FCalendarDate <> aDate then
  begin
   DecodeDate(aDate, aYear, aMonth, aDay);
   FCalendarDate := aDate;
   FYear := Integer(aYear);
   FMonth := Integer(aMonth);
   FDay := Integer(aDay);
   LoadDateArray;
   DateChange;
   Refresh;
  end;
except
  MessageBeep(MB_ICONEXCLAMATION);
 end;
end;

procedure TCalenPnl.SetMonth(Value: Integer);
var
 mDate : TDateType;
 wValue, aY, aM, aD: Word;
 iDaysInM : word;
begin {no test for new <> old as that would fail at startup}
 if (Value < 1) or (Value > 12) then
  begin    {first test}
   MessageBeep(MB_ICONEXCLAMATION);
   Exit;
  end;
 wValue := Word(Value);
 iDaysInM := DaysInMonth(wValue, FYear);
 if iDaysInM < FDay then FDay := iDaysInM;
 with mDate do
  begin
   aMonth := wValue; aDay := Word(FDay); aYear := Word(FYear);
  end;

 if ValidDate(mDate) then  {2nd test}
  begin
   FCalendarDate := EncodeDate(Word(FYear), wValue, Word(FDay));
   DecodeDate( FCalendarDate, aY, aM, aD);
   g_CurrDateIndex := ( aD + GetMonthBegin ) - 1;
   FYear := Integer(aY);
   FMonth := Integer(aM);
   FDay := Integer(aD);
   DateChange;
   LoadDateArray;
   Refresh;
  end
 else MessageBeep(MB_ICONEXCLAMATION);

end;

procedure TCalenPnl.SetDay(Value: Integer);
var
 dDate : TDateType;
 wValue, aY, aM, aD: Word;
begin
 if (Value < 1) or (Value > DaysInMonth(FMonth, FYear)) then
  begin    {first test}
   MessageBeep(MB_ICONEXCLAMATION);
   Exit;
  end;
 wValue := Word(Value);
 with dDate do
  begin
   aMonth := Word(FMonth); aDay := wValue; aYear := Word(FYear);
  end;
 if ValidDate(dDate) then  {2nd test}
  begin
   FCalendarDate := EncodeDate(Word(FYear), Word(FMonth), Value);
   DecodeDate( FCalendarDate, aY, aM, aD);
   g_CurrDateIndex := ( FDay + GetMonthBegin ) - 1;
   FYear := Integer(aY);
   FMonth := Integer(aM);
   FDay := Integer(aD);
   DateChange;
   LoadDateArray;
   Refresh;
  end
 else MessageBeep(MB_ICONEXCLAMATION);
end;

procedure TCalenPnl.SetYear(Value: Integer);
var
 yDate : TDateType;
 iDaysInM, wValue, aY, aM, aD: Word;
begin
 if (Value < 1) or (Value > 9999) then
  begin    {first test}
   MessageBeep(MB_ICONEXCLAMATION);
   Exit;
  end;
 wValue := Word(Value);

 iDaysInM := DaysInMonth(FMonth, wValue);
 if iDaysInM < FDay then FDay := iDaysInM;

 with yDate do
  begin
   aMonth := Word(FMonth); aDay := Word(FDay); aYear := wValue;
  end;
 if ValidDate(yDate) then  {2nd test}
  begin
   FCalendarDate := EncodeDate(wValue, Word(FMonth), Word(FDay));
   DecodeDate(FCalendarDate, aY, aM, aD);
   g_CurrDateIndex := ( FDay + GetMonthBegin ) - 1;
   FYear := Integer(aY);
   FMonth := Integer(aM);
   FDay := Integer(aD);
   DateChange;
   LoadDateArray;
   Refresh;
  end
 else MessageBeep(MB_ICONEXCLAMATION);
end;

procedure TCalenPnl.DrawFocusFrame( nIndex: Integer);
type
  ByteSet = set of Byte;
var
  pDate :PChar;
  TempRect : TRect;
  setSun : ByteSet;     {HK: Changed}
  setSat : ByteSet;     {HK: Added}
  pDate1: string;       {HK: Added}
  pDate2: string;       {HK: Added}
begin
 pDate := StrAlloc( 3 );
 setSun := [];      {HK: Changed}
 setSat := [];      {HK: Added}

 // RW: this set is used throughout the rest of the function
 // RW: so german date has to be checked but once
 if not FGermanDate then
 begin
  setSun := setSun + [1, 8, 15, 22, 29, 36];    {HK: Changed}
  setSat := setSat + [7, 14, 21, 28, 35, 42];   {HK: Added}
 end
 else begin
  setSun := setSun + [7, 14, 21, 28, 35, 42];    {HK: Changed}
  setSat := setSat + [6, 13, 20, 27, 34, 41];    {HK: Changed}
 end;

 If ( nIndex > 0 ) and ( nIndex < 42 ) then
 begin
 //following line works, but may affect DblClick
 //if nIndex = g_PrevDateIndex then exit;
  If g_PrevDateIndex > 0 Then
  begin
   Canvas.Font.Color := clBlack;          {HK: Added}
   if g_PrevDateIndex in setSun then      {HK: Changed}
    Canvas.Font.Color := ColSunday;
   if g_PrevDateIndex in setSat then      {HK: Changed}
    Canvas.Font.Color := ColSaturday;

   Canvas.Font.Style := [];

   pDate1:=g_DateArray[g_PrevDateIndex];   {HK: Added}
   pDate2:=pDate1;                         {HK: Added}
   delete(pDate1,1,1);                     {HK: Added}
   StrPCopy( pDate, pDate1 );              {HK: Changed}

   if CheckHoliday(Holidays, pDate, FMonth) then
    Canvas.Font.Color := ColHoliday;
   if CheckHoliday(Markdays, pDate, FMonth) then
    Canvas.Font.Color := ColMarked;

   if pDate2[1]='-' then
   begin
    Canvas.Font.Color:=clBtnShadow;
   end;

   Canvas.Brush.Color := clBtnFace;
   TempRect := GetRectFromIndex(g_PrevDateIndex);
   Canvas.FillRect(TempRect);
   DrawText( Canvas.Handle, pDate, (Length( g_DateArray[g_PrevDateIndex])-1), {HK: Changed}
             TempRect, ( DT_CENTER or DT_VCENTER or DT_TOP or DT_SINGLELINE ) );
  end;
  
  {Draw the Date in Bold font}

  Canvas.Font.Color := clBlack;          {HK: Added}
  if nIndex in setSun then               {HK: Changed}
   Canvas.Font.Color := ColSunday;
  if nIndex in setSat then               {HK: Changed}
   Canvas.Font.Color := ColSaturday;

  Canvas.Font.Style := [fsBold];
  TempRect := GetRectFromIndex(nIndex);

  pDate1:=g_DateArray[nIndex];            {HK: Added}
  pDate2:=pDate1;                         {HK: Added}
  delete(pDate1,1,1);                     {HK: Added}
  StrPCopy( pDate, pDate1 );              {HK: Changed}


  // RW: check for holiday once more
  if CheckHoliday(Holidays, pDate, FMonth) then
   Canvas.Font.Color := ColHoliday;
  if CheckHoliday(Markdays, pDate, FMonth) then
   Canvas.Font.Color := ColMarked;

  {HK: Added}
  if pDate2[1]='-' then
  begin
   Canvas.Font.Color:=clBtnShadow;
  end;

  DrawText( Canvas.Handle, pDate, (Length( g_DateArray[nIndex])-1 ),  {HK: Changed}
            TempRect, ( DT_CENTER or DT_VCENTER or DT_TOP or DT_SINGLELINE ) );
  { Frame date with Shadow }
  Canvas.Pen.Color := clBtnShadow;   {clGray}
  Canvas.MoveTo( TempRect.Left, TempRect.Bottom - 1 );
  Canvas.LineTo( TempRect.Left, TempRect.Top );
  Canvas.LineTo( TempRect.Right - 1, TempRect.Top );
  { Frame date with Highlight }
  Canvas.Pen.Color := clBtnHighlight;    {clWhite}
  Canvas.LineTo( TempRect.Right - 1, TempRect.Bottom - 1 );
  Canvas.LineTo( TempRect.Left, TempRect.Bottom - 1 );
  { Restore Canvas settings}
  Canvas.Pen.Color := clBlack;
  Canvas.Font.Style := [];
 end;
 StrDispose( pDate );
end;

function TCalenPnl.GetRectFromIndex(nIndex : Integer): TRect;  {1}
var
  TempRect: TRect;
  nWeek : Integer;
  nDay : Integer;
begin
  TempRect := CalendarRect;
  with TempRect do
     begin
      nWeek := 1;    //if not initialized bloody Syntax checker returns cursor
      case nIndex of //here after compile, losing ones place!
            1..7 :  nWeek := 1;
            8..14:  nWeek := 2;
            15..21: nWeek := 3;
            22..28: nWeek := 4;
            29..35: nWeek := 5;
            36..42: nWeek := 6;
       end;
       nDay := nIndex - ((nWeek-1) *7);
       Left := Left + (g_Width * (nDay-1));
       Top := Top + (g_RectHeight * (nWeek - 1) );
       Bottom := Top +  g_RectHeight ;
       Right := Left + g_Width;
     end;
  Result := TempRect;
end;

function TCalenPnl.GetIndexFromDate : Integer;
begin
 Result := FDay + GetMonthBegin;
end;

function TCalenPnl.GetIndexFromPoint(nLeft : Integer ; nTop : Integer) : Integer;
var
  nIndex, nWeek, nDay, iHorizontal, iTopOfCal: Integer;
  TempRect: Trect;
begin
  TempRect := CalendarRect;
  iTopOfCal := TempRect.Top;
  nIndex := -1;
  {Is point in the calendar rectangle?}
  if ( nLeft > TempRect.Left ) and ( nTop > TempRect.Top ) and
      ( nLeft < TempRect.Right ) and ( nTop < TempRect.Bottom ) then
     begin
        iHorizontal := (( nTop - iTopOfCal ) div g_RectHeight) + 1;
        if iHorizontal <= 0 then iHorizontal := 1; {if its in the CalenRect then its valid}
        nWeek := iHorizontal;
        TempRect.Top := TempRect.Top + ( ( nWeek - 1 ) * g_RectHeight );
        TempRect.Bottom := TempRect.Top + g_RectHeight;
        TempRect.Right := TempRect.Left + g_Width;
        { Determine the day number of the selected date }
        for nDay := 1 to 7 do        {Cycle through the days}
           begin
              nIndex := nDay + ( ( nWeek - 1 ) * 7 );
              if ( nLeft >= TempRect.Left ) and ( nLeft <= TempRect.Right ) then
                 break
              else
                 begin
                    TempRect.Left := TempRect.Right;
                    TempRect.Right := TempRect.Left + g_Width;
                 end;
           end;
     end;
  Result := nIndex;
end;

function TCalenPnl.GetLeftButtonRect: TRect;
var
  TempRect: TRect;
  iHt: Integer;
begin
   {Define Left Button Rectangle}
   iHt := (HeadingRect.Bottom - HeadingRect.Top) div 15;
   TempRect.Top := HeadingRect.Top + iHt;
   TempRect.Bottom := TempRect.Top + BUTTON_WIDTH;
   iHt := (HeadingRect.Right - HeadingRect.Left) div 30;
   TempRect.Left := HeadingRect.Left + iHt;
   TempRect.Right := TempRect.Left + BUTTON_WIDTH;
   Result := TempRect;
end;

function TCalenPnl.GetRightButtonRect: TRect;
var
  TempRect: TRect;
  iHt: Integer;
begin
   {Define Right Button Rectangle}
   iHt := (HeadingRect.Bottom - HeadingRect.Top) div 15;
   TempRect.Top := HeadingRect.Top + iHt;
   TempRect.Bottom := TempRect.Top + BUTTON_WIDTH;
   iHt := (HeadingRect.Right - HeadingRect.Left) div 30;
   TempRect.Left := HeadingRect.Right - (BUTTON_WIDTH + iHt);
   TempRect.Right := TempRect.Left + BUTTON_WIDTH;
   Result := TempRect;
end;

procedure TCalenPnl.KeyDown(var Key: Word; Shift: TShiftState);
var
 iDaysIncrM, iDaysToAdd, iIncrM: integer;
begin
    Case key of
     VK_Left : begin  {PrevDay;}
                if (FMonth = 1) and (FYear = 1) and (FDay = 1) then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
                if Not SetDate(-1)then exit;
                If (FMonth <> g_PrevMonth) or
                   (FYear <> g_PrevYear) Then Refresh
                    else DrawFocusFrame(g_CurrDateIndex);
                end;
     VK_Right: begin  {NextDay;}
                if (FMonth = 12) and (FYear = 9999) and (FDay = 31) then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
                if Not SetDate(1) then exit;
                If (FMonth <> g_PrevMonth) or
                   (FYear <> g_PrevYear) Then Refresh
                    else DrawFocusFrame(g_CurrDateIndex);
                end;
     VK_Up :   begin  {PrevWeek;}
                if (FMonth = 1) and (FYear = 1) and (FDay < 7) then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
                if Not SetDate(-7) then exit;
                If (FMonth <> g_PrevMonth) or
                   (FYear <> g_PrevYear) Then Refresh
                    else DrawFocusFrame(g_CurrDateIndex);
                end;
     VK_Down : begin {NextWeek;}
                if (FMonth = 12) and (FYear = 9999) and (FDay > 24) then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
                if Not SetDate(7) then exit;
                If (FMonth <> g_PrevMonth) or
                   (FYear <> g_PrevYear) Then Refresh
                    else DrawFocusFrame(g_CurrDateIndex);
               end;
     VK_Prior: begin {PrevMonth;}
                if (FMonth = 1) and (FYear = 1) then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
                if FMonth > 1 then iIncrM := FMonth -1 else iIncrM := 12;
                iDaysIncrM := DaysInMonth(iIncrM, FYear);
                if (iDaysIncrM < FDay) then
                  iDaysToAdd := DaysInMonth(FMonth, FYear)
                  else iDaysToAdd := iDaysIncrM;
                try
                 if Not SetDate(-iDaysToAdd) then exit;
                 Refresh;
                except
                 MessageBeep(MB_ICONEXCLAMATION);
                end;
               end;
     Vk_Next : begin  {NextMonth;}
                if (FMonth = 12) and (FYear = 9999) then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
                if FMonth = 12 then iIncrM := 1 else iIncrM := FMonth + 1;
                iDaysIncrM := DaysInMonth(iIncrM, FYear);
                if (iDaysIncrM < FDay) then iDaysToAdd := iDaysIncrM
                  else iDaysToAdd := DaysInMonth(FMonth, FYear);
                try
                 if Not SetDate(iDaysToAdd) then exit;
                 Refresh;
                except
                 MessageBeep(MB_ICONEXCLAMATION);
                end;
               end;
     VK_Home : begin {NextYear;}
{If the current year is a leap year and the date is before February 29, add 1 day}
                if FYear = 9999 then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
                If IsLeapYear(FYear) and
                  (FMonth < 3) Then if Not SetDate(1) then exit;
                if Not SetDate(365) then exit;
{If the current year is a leap year and the date is after February 29, add 1 day}
                If IsLeapYear(FYear) and
                  (FMonth > 3) Then if Not SetDate(1) then exit;
                Refresh;
               end;
     VK_End :  begin {PrevYear;}
                if FYear = 1 then
                 begin
                  MessageBeep(MB_ICONEXCLAMATION);
                  exit;
                 end;
{If the current year is a leap year and the date is after February 29, subtract 1 day}
                If IsLeapYear(FYear) and
                 (FMonth > 3) Then if Not SetDate(-1) then exit;
                if Not SetDate(-365) then exit;
{If the Previous year is a leap year and the date is before February 29, subtract 1 day}
                If IsLeapYear(FYear) and
                 (FMonth < 3) Then if Not SetDate(-1) then exit;
                Refresh;
               end;
    VK_Return: begin
               {TDateEdit( ctlParent ).Date := m_CurrentDateSelected; }
               {maybe you have a use for the Return or Esc keys}
               end;
  {VK_Escape : FormCancel;}
     else

     end;
end;

procedure TCalenPnl.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TCalenPnl.MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
var
  nIndex : Integer;
begin
  inherited MouseDown(Button, Shift, X, Y);
  MouseX:=X; MouseY:=Y;  {HK: Added for DblClick-Support in the Calendar-Rect only}

  {Check if mouse was pressed in date area} // ouch!
  if PointInRect(CalendarRect, X, Y) then
  begin
   g_MouseDown := True;
   nIndex := GetIndexFromPoint( X, Y );
   If (nIndex >= GetMonthBegin) and
      (nIndex < (DaysInMonth(FMonth, FYear) + GetMonthBegin)) Then
   begin
    if Not SetDate(nIndex - g_CurrDateIndex) then exit;
    DrawFocusFrame(nIndex);
    DateChange;
    end
    else
     g_MouseDown := False;
  end;
end;

procedure TCalenPnl.DateChange;
begin
 if Assigned(FOnDateChange) then FOnDateChange(Self);
end;


procedure TCalenPnl.DecMonth;     //HK:Added
var Key: Word;
    Shift: TShiftState;
begin
 Key:=Vk_Prior;
 KeyDown(Key,Shift);
 DateChange;
end;

procedure TCalenPnl.IncMonth;     //HK:Added
var Key: Word;
    Shift: TShiftState;
begin
 Key:=Vk_Next;
 KeyDown(Key,Shift);
 DateChange;
end;

procedure TCalenPnl.HideButtons;    //HK:Added
begin
 DecMonthButton.Hide;
 IncMonthButton.Hide;
end;

procedure TCalenPnl.ShowButtons;    //HK:Added, Show Buttons removed
var BtnRect: TRect;
begin
 BtnRect:=GetLeftButtonRect;
 DecMonthButton.Left:=BtnRect.Left;
 DecMonthButton.Top:=BtnRect.Top;
 DecMonthButton.Height:=BtnRect.Bottom-BtnRect.Top;
 DecMonthButton.Width:=BtnRect.Right-BtnRect.Left;
 DecMonthButton.Show;

 BtnRect:=GetRightButtonRect;
 IncMonthButton.Left:=BtnRect.Left;
 IncMonthButton.Top:=BtnRect.Top;
 IncMonthButton.Height:=BtnRect.Bottom-BtnRect.Top;
 IncMonthButton.Width:=BtnRect.Right-BtnRect.Left;
 IncMonthButton.Show;

 if FGermanDate then         //Set Hint-Strings
 begin
  DecMonthButton.Hint:='Letzter Monat';
  IncMonthButton.Hint:='Nchster Monat';
 end
 else begin
  DecMonthButton.Hint:='Previous Month';
  IncMonthButton.Hint:='Next Month';
 end;

 if FShowButtonHints then
 begin
  DecMonthButton.ShowHint:=True;
  IncMonthButton.ShowHint:=True;
 end
 else begin
  DecMonthButton.ShowHint:=False;
  IncMonthButton.ShowHint:=False;
 end;
end;

function TCalenPnl.JulDate1stWeek(JD : TDateTime) : TDateTime;
  {-Return the Date of the first day in the week of Julian Year}
var
  aYear, aMonth, aDay : Word;
  JDate     : TDateTime;
begin
  DecodeDate(JD, aYear, aMonth, aDay);
  JDate := EncodeDate(aYear, 1, 1);

  if FGermanDate then
  begin
   if rDayOfWeek(JDate) in [5,6,7] then        //1.1. ist Fr, Sa, So
   begin
    JDate:=JDate+(8-rDayOfWeek(JDate));       //Dann gehrt diese Woche
                                              //noch zum letzten Jahr
   end                                        //JDate auf nchsten Montag erhhen
   else begin
    if rDayOfWeek(JDate)>1 then
     JDate:=JDate-(rDayOfWeek(JDate)-1);      //Sonst JDate auf Montag erniedrigen
   end;
  end
  else begin
   if rDayOfWeek(JDate) in [6,7,1] then           //1.1. ist Fr, Sa, So
   begin
    if rDayOfWeek(JDate)>1 then                   //Dann gehrt diese Woche
      JDate:=JDate+(8-rDayOfWeek(JDate));         //noch zum letzten Jahr
   end                                            //JDate auf nchsten Montag erhhen
   else begin
    JDate:=JDate-(rDayOfWeek(JDate)-1);           //Sonst JDate auf Montag erniedrigen
   end;
  end;
  Result := JDate
end;

function TCalenPnl.WeekNo(JDate : TDateTime) : Integer;
var
  W1,W2,W3    : TDatetime;
  d1,d2,d3    : TDatetime;
  yy,mm,dd    : word;
begin
  W1:=JulDate1stWeek(JDate);
  W2:=W1; W3:=W1; //Vorbelegen
  DecodeDate(JDate, yy, mm, dd);  // voriges Jahr
  if yy>0 then
  begin
   d2:=EncodeDate(yy-1, 12, 31);
   W2:=JulDate1stWeek(d2);
  end;
  if yy<9999 then
  begin
   d3:=EncodeDate(yy+1, 1, 1);     // nchstes Jahr
   W3:=JulDate1stWeek(d3);
  end;

  if W3<=JDate then              //Woche gehrt schon zum nchsten Jahr
  begin
   d1:=JDate-W3;
   Result := (trunc(d1)div 7)+1;
   Exit;
  end;

  if W1>JDate then              //Woche gehrt noch zum vorigem Jahr
  begin
   d1:=JDate-W2;
   Result := (trunc(d1)div 7)+1;
   Exit;
  end;

  d1:=JDate-W1;                 //Normalfall
  Result := (trunc(d1)div 7)+1;
end;

function TCalenPnl.GetWeekNumber: Integer;
begin
 Result := WeekNo(EncodeDate(FYear, FMonth, FDay));
end;

function TCalenPnl.DOY(y, m, d : Word) : Integer;
var
 yy, mm, dd, Tmp1 : LongInt;
begin
  yy := y;
  mm := m;
  dd := d;
  Tmp1 := (mm + 10) div 13;
  DOY :=  3055 * (mm + 2) div 100 - Tmp1 * 2 - 91 +
                  (1 - (yy - yy div 4 * 4 + 3) div 4 +
                  (yy - yy div 100 * 100 + 99) div 100 -
                  (yy - yy div 400 * 400 + 399) div 400) * Tmp1 + dd
end;  { DayOfYear }

function TCalenPnl.GetDayOfYear: Integer;
begin
 result := DOY(FYear, FMonth, FDay);
end;

function TCalenPnl.GetDaysInYear: integer;
begin
 If IsLeapYear(FYear) then Result := 366 else result := 365;
end;

// RW: added these functions
// Toggles start of the week (Sunday or Monday)
procedure TCalenPnl.SetGermanDate(Value: Boolean);
begin
  if Value <> FGermanDate then
  begin
    FGermanDate := Value;
    LoadDateArray;
    Refresh;
  end;
end;

procedure TCalenPnl.SetShowWeeks(Value: Boolean);    {HK: Added}
begin
  if Value <> FShowWeeks then
  begin
   FShowWeeks := Value;
   LoadDateArray;                   
   Refresh;
  end;
end;

// Corrected built-in-function to fit german date
function TCalenPnl.rDayOfWeek(vDate: TDateTime) : Integer;
begin
  Result := DayOfWeek(vDate);
  if FGermanDate then
  begin
     Result := Result - 1;            // Sonntag abziehen / subtract Sunday
     if Result = 0 then Result := 7;  // Fehler ausgleichen / error correction
  end;
end;

// functions to set color values
procedure TCalenPnl.SetColHoliday(Value: TColor);
begin
  if Value <> FColHoliday then
  begin
     FColHoliday := Value;
     Refresh;
  end;
end;

procedure TCalenPnl.SetColSunday(Value: TColor);    {HK: Changed}
begin
  if Value <> FColSunday then
  begin
     FColSunday := Value;
     Refresh;
  end;
end;

procedure TCalenPnl.SetColSaturday(Value: TColor);     {HK: Added}
begin
  if Value <> FColSaturday then
  begin
     FColSaturday := Value;
     Refresh;
  end;
end;
procedure TCalenPnl.SetColMarked(Value: TColor);
begin
  if Value <> FColMarked then
  begin
     FColMarked := Value;
     Refresh;
  end;
end;

// build a string list for Holidays
procedure TCalenPnl.SetHolidays(Value: TStrings);
begin
  Holidays.Assign (Value);
end;

// build a string list for special days
procedure TCalenPnl.SetMarkdays(Value: TStrings);
begin
  Markdays.Assign (Value);
end;

// RW: this function compares a given day and month with the strings
// of a stringlist to find out about holidays and special days
function TCalenPnl.CheckHoliday(DateList: TStrings; sd: PChar; m: integer) : Boolean;
var
  i, z: integer;
  scmp, sm: string;
begin
  // Anzahl der Listeneintrge bestimmen
  // Determine number of listentries
  z := Datelist.Count - 1;
  Result := False;
  scmp := '';
  if (Datelist.Count > 0) and (sd <> ' ') and (m > 0) then begin
     // Vergleichsstring basteln
     // Create compare string
     Str(m, sm);
     if FGermanDate then
        scmp:= sd + '.' + sm + '.'
     else
        scmp:= sm + '/' + sd + '/';
     // Liste durchgehen, alle Eintrge vergleichen
     // Step through the list and compare all entries
     for i := 0 to z do begin
        if scmp = Datelist.Strings[i] then begin
           Result := True;
           break;
        end;
     end;
  end;
end;

procedure TCalenPnl.DblClick;        {HK: DblClick works now only in CalendarRect}
begin
 if PointInRect(CalendarRect, MouseX, MouseY) then
 begin
  inherited DblClick;
 end;
end;

end.
